;;; $Id: plugin-listener.lisp,v 1.2 2004/02/19 18:10:59 boelthorn Exp $
(def-xchat-plugin "ECL Listener"
    :version "0.1"
    :package-name "PLUGIN-LISTENER"
    :description "Provides /lisp command")

;;; This provides some kind of REPL.

(defun cycle-asterisks (new)
  (psetq *** **
	 ** *
	 * new)
  new)

(defun cbListener (word word_eol)
  (xchat::bind-if (code (second word_eol))
		  (xchat::xchat-safe-eval
		   (let ((input (let ((*package* (find-package "PLUGIN-LISTENER"))) 
				  (read-from-string code))))
		     (format t "~&~S -> ~S~%"
			    input (cycle-asterisks (eval input)))))
		  (format t "You need to specify an argument to this command!"))
  +XCHAT-EAT-ALL+)

;; *plugin* defined by def-xchat-plugin
(%hook-command *plugin* "lisp" #'cbListener "Usage: /lisp <code>")

